#include "RandomNimPlayer.hpp"
#include "NimMoveSelector.hpp"
#include "UniformIntDistribution.hpp"

static UniformIntDistribution uniform_int;

RandomNimPlayer::RandomNimPlayer() : name("Randy") {
}

const std::string& RandomNimPlayer::get_name() const {
   return name;
}

NimMove RandomNimPlayer::get_move(const NimGame& game) const {
   NimMoveSelector selector;
   unsigned int number_of_heaps = game.get_number_of_heaps();
   unsigned int maxtake = game.get_maximal_take();
   for (unsigned int i = 0; i < number_of_heaps; ++i) {
      unsigned int max = game.get_heap_size(i);
      if (maxtake && max > maxtake) max = maxtake;
      for (unsigned int count = 1; count <= max; ++count) {
	 selector.add(NimMove(i, count));
      }
   }
   return selector.get();
}

// support dynamic loading
extern "C" NimPlayer* construct() {
   return new RandomNimPlayer();
}
